{
 Cerinte:
   - abscisele si ordonatele fiecarui lot sint unice
   - loturile formeaza o multime conexa
}

uses graph, crt;
const  infty = 20000000;
nr_max_drept = 500;

type
  DIRECTION = (UP, DOWN, ZERO);
  punct = record
            x, y : real;
          end;
  dreptunghi = record
            NV, SE : punct;
               end;

  pMuchie = ^muchie;
  muchie = record
             x, y1, y2: real;
             used     : boolean;
             next     : pMuchie;
             points   : DIRECTION;
           end;
var
  D     : array[1..nr_max_drept] of dreptunghi;
  nr_d,                   { nr. de dreptunghiuri }
  nr_y  : word;            { nr. de ordonate      }
  events: array[1..nr_max_drept * 2 + 1] of record
                 x: real;
                 tip: (inceput, sfirsit);
                 b, t: real
               end;
  l_stat: array[1..nr_max_drept * 2] of record
            y: real;
            nr_supra: word;
          end;
  V     : pMuchie;  { tabloul de muchii verticale }
  nV    : integer;  { nr. de muchii verticale     }
  xmin, xmax,
  ymin, ymax,
  rx, ry : real;
  shift_left, shift_up: integer;
  NrMlast : integer;
  TEST  : boolean;
  leftmost : muchie;

procedure wait;
var c: char;
begin
  c := readkey;
  case c of
  #27: halt(1);
  'T','t': TEST := not TEST;
  end;
end;

procedure switch(var a, b: real);
var aux: real;
begin
  aux:=a; a:=b; b:=aux
end;

procedure pSwitch ( A, B: pMuchie);
begin
  switch(A^.x,  B^.x);
  switch(A^.y1, B^.y1);
  switch(A^.y2, B^.y2);
end;

procedure InsOrd(x, y1, y2: real; d: DIRECTION; var L : pMuchie);
var p, aux: pMuchie;
begin

  new(aux);
  aux^.x  := x;
  aux^.y1 := y1;
  aux^.y2 := y2;
  aux^.used   := false;
  aux^.points := d;

  if L = nil then
  { lista vida }
   begin
     L := aux;
     L^.next := nil;
   end
  else
   begin
     p := L;
     if (y1<p^.y1) or ((y1=p^.y1) and (x<p^.x)) then
     { mai mic ca primul nod }
      begin
        aux^.next := L;
        L         := aux;
      end
     else
      begin
        while (not ((y1<p^.next^.y1) or
              ((y1=p^.next^.y1) and (x<p^.next^.x)))) and
              (p^.next<>nil) do
          p:=p^.next;
        if p^.next=nil then
        { cel mai mare }
         begin
           aux^.next := nil;
           p^.next := aux
         end
        else
        { undeva in lista }
         begin
           aux^.next := p^.next;
           p^.next   := aux;
         end;
      end;
   end;
end;

procedure Delete(p: pMuchie; var L: pMuchie);
var q: pMuchie;
begin
  if p = L then
   begin
     L := L^.next;
     dispose(p)
   end
  else
   begin
     q := L;
     while q^.next <> p do q := q^.next;
     q^.next := q^.next^.next;
     dispose(p)
   end;
end;

procedure ReadDrept;
var s: string;
    f: text;
begin
  ClrSCr;
  Write('Introduceti numele fisierului din care citesc dreptunghiurile ');
  ReadLn(s);
  assign(f, s);
  reset(f);
  nr_d := 0;
  while not eof(f) do
   begin
     inc(nr_d);
     with D[nr_d] do
      begin
       ReadLn(f, NV.x, NV.y, SE.x, SE.y);
       if NV.x > SE.x then switch(NV.x, SE.x);
       if NV.y < SE.y then switch(NV.y, SE.y);
      end;
   end;

end;

procedure DesenDrept;
var gd, gm, i: integer;
begin
  ymin := D[1].SE.y;
  ymax := D[1].NV.y;
  xmin := D[1].NV.x;
  xmax := D[1].SE.x;
  for i:=2 to nr_d do
  begin
   if D[i].SE.y<ymin then
      ymin := D[i].SE.y;
   if D[i].NV.y>ymax then
      ymax := D[i].NV.y;
   if D[i].SE.x>xmax then
      xmax := D[i].SE.x;
   if D[i].NV.x<xmin then
      xmin := D[i].NV.x;
  end;
  gd := detect;
  initgraph(gd, gm, 'e:\bp7\bgi');
  rx := GetMaxX / (xmax - xmin) ;
  ry := GetMaxY / (ymax - ymin);
  if rx < ry then
   begin
     ry := rx;
     shift_left := 0;
     shift_up := (GetMaxY - trunc((ymax - ymin)*ry)) div 2
   end
  else
   begin
     rx := ry;
     shift_left := (GetMaxX - trunc((xmax - xmin) * rx)) div 2;
     shift_up := 0
   end;
  setfillstyle(solidfill, blue);
  for i:= 1 to nr_d do
    begin
{
     delay(1000);
}
     setfillstyle(solidfill, 1+random(14));
     bar(shift_left + trunc((D[i].NV.x - xmin) * rx),
         GetMaxY - trunc((D[i].NV.y - ymin) * ry) - shift_up,
         shift_left + trunc((D[i].SE.x - xmin) * rx),
         GetMaxY - trunc((D[i].SE.y - ymin) * ry) - shift_up );
    end;
end;

procedure bubble;
var i: integer;
    k: boolean;
begin
  repeat
    k:=true;
    for i:=1 to 2 * nr_d - 1 do
     if (events[i].x < events[i+1].x) or
        ((events[i].x=events[i+1].x) and
         (events[i].tip<=events[i+1].tip)) then
     else
      begin
        k:=false;
        events[2 * nr_max_drept + 1] := events[i];
        events[i]:=events[i+1];
        events[i+1]:=events[2 * nr_max_drept + 1]
      end;
    until k
end;

procedure CreateEvents;
var i: word;
begin
  for i:=1 to nr_d do
   begin
     with events[2*(i-1) + 1] do
      begin
        x   := D[i].NV.x;
        tip := inceput;
        b   := D[i].SE.y;
        t   := D[i].NV.y
      end;
     with events[2*(i-1) + 2] do
      begin
        x   := D[i].SE.x;
        tip := sfirsit;
        b   := D[i].SE.y;
        t   := D[i].NV.y
      end;
   end;
  bubble
end;

procedure CreateStatus;
var i:word;

procedure BinSort;
type  key = real;
      ref = ^nod;
      nod = record
              info  : key;
              Fs, Fd: ref
            end;
var a: ref;
    x: key;
    i: integer;
procedure insert(var a: ref; k: key);
begin
  if a=nil then
   begin
     new(a);
     a^.fs:=nil;
     a^.fd:=nil;
     a^.info:=k
   end
  else
   if k<a^.info then insert(a^.fs, k)
   else if k>a^.info then insert(a^.fd,k);
end;
procedure crearb(var a: ref);
var x: key;
    var i:word;
begin
  a:=nil;
  for i:=1 to 2 * nr_d do
    insert(a,l_stat[i].y);
end;
procedure parcurg(var a:ref);
begin
    if a<>nil then
   begin
    if a^.fs<>nil then parcurg(a^.fs);
    inc(i);
    l_stat[i].y := a^.info;
    if a^.fd<>nil then parcurg(a^.fd)
   end
end;
begin
  a:=nil;
  crearb(a);
  i:=0;
  parcurg(a);
  nr_y := i
end; { BINSORT }

begin
  for i := 1 to nr_d do
    begin
      with l_stat[2 * (i - 1) + 1] do
       begin
          y := D[i].SE.y;
          nr_supra := 0;
       end;
      with l_stat[2 * (i - 1) + 2] do
       begin
          y := D[i].NV.y;
          nr_supra := 0;
       end;
    end;
  BinSort
end;

{***********  That's it! ***************}

procedure Sweep;
var i : word;
    yB, yE: real;
    y1, y2: real;

procedure AdInterval(x, b, t: real);
{ adauga la lista de muchii toate portiunile
  din latura curenta in contact cu exteriorul;
  exteriorul poate fi doar la stinga,
  caci latura e din stinga unui dreptunghi }
var k, k1, k2: integer;
begin

  k  := 1;
  while l_stat[k].y < b do inc(k); { am ajuns la primul int. elementar }
  k1 := k;                         { k1 - pozitia lui b }
  while l_stat[k].y < t do inc(k);
  k2 := k;                         { k2 - pozitia lui t }
  k  := k1;

  repeat
    while (k<k2) and (l_stat[k].nr_supra > 0) do inc(k);
    if k<k2 then
     begin
       inc(nV);
       y1 := l_stat[k].y;
       while (k<k2) and (l_stat[k].nr_supra = 0) do inc(k);
       y2 := l_stat[k].y;
       InsOrd(x, y2, y1, DOWN, V);
{
       Line(shift_left + trunc((x - xmin) * rx),
            getmaxy - trunc((y1 - yMin) * ry)- shift_up,
            shift_left + trunc((x - xmin) * rx),
            getmaxy - trunc((y2 - yMin) * ry)- shift_up);
}
    end
  until k >= k2;

  for k:=k1 to k2-1 do
   inc(l_stat[k].nr_supra);
end;
procedure DelInterval(x, b, t: real);
var k, k1, k2: integer;
    y1, y2: real;
begin
  k  := 1;
  while l_stat[k].y < b do inc(k); { am ajuns la primul int. elementar }
  k1 := k;                         { k1 - pozitia lui b }
  while l_stat[k].y < t do inc(k);
  k2 := k;                         { k2 - pozitia lui t }
  k  := k1;

  for k:=k1 to k2-1 do
   dec(l_stat[k].nr_supra);

  k := k1;
  repeat
    while (k<k2) and (l_stat[k].nr_supra > 0) do inc(k);
    if k<k2 then
     begin
       inc(nV);
       y1 := l_stat[k].y;
       while (k<k2) and (l_stat[k].nr_supra = 0) do inc(k);
       y2 := l_stat[k].y;
       InsOrd(x, y1, y2, UP, V);
{
       Line(shift_left + trunc((x - xmin) * rx),
            getmaxy - trunc((y1 - yMin) * ry)- shift_up,
            shift_left + trunc((x - xmin) * rx),
            getmaxy - trunc((y2 - yMin) * ry)- shift_up);
}
     end
  until k = k2;

end;
var s:string;
begin
  nV := 0;
  V := nil;
  SetColor(green);
  AdInterval(events[1].x, events[1].b, events[1].t);

  SetFillStyle(emptyfill, 0);

  for i:=2 to 2 * nr_d do
   begin
     if events[i].tip = inceput then
       AdInterval(events[i].x, events[i].b, events[i].t)
     else
       DelInterval(events[i].x, events[i].b, events[i].t);
     Bar(560, 450, 640, 480);
   end;
end;

procedure Count;
{
  - dublez fiecare muchie din V
  - sortez V in ordine lexicografica, dupa y1 si apoi x
  - numar ciclurile interioare
}
var i, j, k, iMin,treceri: integer;
    gata: boolean;
    c : char;
    VD, p, aux: pMuchie;
    xNext, yNext1, yNext2,
    yIni1, yIni2, xIni : real;
    f: text;
    s: string;
begin

  p := V;
  new(VD);
  VD^ := V^;
  VD^.next := nil;
  switch(VD^.y1, VD^.y2);

  p := V^.next;
  while p<>nil do
   begin
     new(aux);
     aux^      :=p^;
     aux^.next := VD;
     VD        := aux;
     switch(VD^.y1, VD^.y2);
     p         := p^.next;
   end;

   p := VD;
   while p<>nil do
    begin
      InsOrd(p^.x, p^.y1, p^.y2, p^.points, V);
      p := p^.next
    end;

  { Pun orizontalele }
  p := V;
  while p<>nil do
   begin
     new(aux);
     aux^.next := p^.next;
     aux^.x := p^.y1;
     aux^.y1 := p^.x;
     aux^.y2 := p^.next^.x;
     aux^.points := ZERO;

     p^.next := aux;
     p := p^.next^.next^.next;
   end;

{
  assign(f, 'muchii.dat');
  rewrite(f);
  p := V;
  while p<>nil do
   begin
     Write(f, p^.x:8:4, ' ', p^.y1:8:4, ' : ', p^.y2:8:4, '->' );
     case p^.points of
     UP  : WriteLn(f, 'UP');
     DOWN: WriteLn(f, 'DOWN');
     ZERO: WriteLn(f, 'ZERO');
     end;
     p:=p^.next;
   end;
   close(f);
}
   setlinestyle(SolidLn, 0, ThickWidth);
   setcolor(15);
   { fac ciclurile }
   NrMlast := 0;
   repeat
     { procesez primele trei muchii din V }
{
     inc(NrMlast);
}

     p := V;
     xIni  := p^.x;
     yIni1 := p^.y1;
     yIni2 := p^.y2;

     leftmost := p^;

     xNext  := p^.next^.next^.x;
     yNext1 := p^.next^.next^.y2;
     yNext2 := p^.next^.next^.y1;
     Line(shift_left + trunc((p^.x - xmin) * rx),
          getmaxy - trunc((p^.y1 - yMin) * ry)- shift_up,
          shift_left + trunc((p^.x - xmin) * rx),
          getmaxy - trunc((p^.y2 - yMin) * ry)- shift_up);
     Delete (p, V);
     p := V;
     Line(shift_left + trunc((p^.y1 - xmin) * rx),
          getmaxy - trunc((p^.x - yMin) * ry)- shift_up,
          shift_left + trunc((p^.y2 - xmin) * rx),
          getmaxy - trunc((p^.x - yMin) * ry)- shift_up);
     Delete (p, V);
     p := V;
     if leftmost.x > p^.x then
       leftmost := p^;
     Line(shift_left + trunc((p^.x - xmin) * rx),
          getmaxy - trunc((p^.y1 - yMin) * ry)- shift_up,
          shift_left + trunc((p^.x - xmin) * rx),
          getmaxy - trunc((p^.y2 - yMin) * ry)- shift_up);
{
     readln;
}
     Delete(p, V);
     { elimin restul muchiilor din ciclu }
     gata := false;
     p := V;
     repeat
       if p=nil then p:=V;
       treceri := 0;
       while not(((p^.y1 = yNext1) and
                  (p^.y2 = yNext2) and
                  (p^.x = xNext))                 or
                 ((p^.next^.next^.y1 = yNext1) and
                  (p^.next^.next^.y2 = yNext2) and
                  (p^.next^.next^.x  = xNext)))
         and (treceri<2) do
        if p^.next^.next^.next = nil then
           begin
             p:=V;
             inc(treceri);
           end
         else p:=p^.next^.next^.next;
       if treceri<2 then
        begin
          if leftmost.x > p^.x then
           leftmost := p^;

          aux := p^.next;
          if ((p^.y1 = yNext1) and
              (p^.y2 = yNext2) and
              (p^.x = xNext))
           then
            begin
              xNext  := p^.next^.next^.x;
              yNext1 := p^.next^.next^.y2;
              yNext2 := p^.next^.next^.y1;
            end
           else
            begin
              xNext  := p^.x;
              yNext1 := p^.y2;
              yNext2 := p^.y1;
            end;
          Line(shift_left + trunc((p^.x - xmin) * rx),
               getmaxy - trunc((p^.y1 - yMin) * ry)- shift_up,
               shift_left + trunc((p^.x - xmin) * rx),
               getmaxy - trunc((p^.y2 - yMin) * ry)- shift_up);
          Delete (p, V);
          p := aux;
          aux := p^.next;
          Line(shift_left + trunc((p^.y1 - xmin) * rx),
               getmaxy - trunc((p^.x - yMin) * ry)- shift_up,
               shift_left + trunc((p^.y2 - xmin) * rx),
               getmaxy - trunc((p^.x - yMin) * ry)- shift_up);
          Delete (p, V);
          p := aux;
          if leftmost.x > p^.x then
            leftmost := p^;
          aux := p^.next;
          Line(shift_left + trunc((p^.x - xmin) * rx),
               getmaxy - trunc((p^.y1 - yMin) * ry)- shift_up,
               shift_left + trunc((p^.x - xmin) * rx),
               getmaxy - trunc((p^.y2 - yMin) * ry)- shift_up);
{
          readln;
}
          Delete(p, V);
          p := aux;
        end;
     until (xNext = xIni) and
           (yNext1 = yIni1) and
           (yNext2 = yIni2) ;
     if leftmost.points=UP then
      begin
        inc(NrMlast);
        Bar(560, 450, 640, 480);
        str(NrMlast:2, s);
        OutTextXY(560, 450, s);
      end;
        if test then wait
         else delay(100);
   until V = nil;

end;

begin
  TEST := true;
  randomize;
  ReadDrept;
  DesenDrept;
  setcolor(white);
  OutTextXY(540, 400, 'A second, ');
  OutTextXY(540, 415, 'please...');
  CreateEvents;
  CreateStatus;
  OutTextXY(540, 430, 'Press ENTER');
  readln;
  closegraph;
  DesenDrept;
  Sweep;
  Count;
  closegraph;
  GotoxY(34,12);
  if NrMlast>1 then
    Write('Au fost ',NrMlast,' mlastini.')
  else
   if NrMlast = 1 then
     Write('A fost o mlastina.')
   else WriteLn('N-a fost nici o mlastina.');
  readln;
end.
